#!/bin/sh

echo "Start firmware upgrading"

FW_PATH="/tmp/fw"

FMW_BOARD_TYPE="$(cat $FW_PATH/fmw_board_type)"
if [ "$FMW_BOARD_TYPE" != "RG34" ]; then
    echo "UPDATE FAIL: board is RG34, but firmware is $FMW_BOARD_TYPE"
    exit 1
fi

md5_cur=$(busybox md5sum "$FW_PATH"/linux.bin | cut -d' ' -f 1)
md5_img=$(cat "$FW_PATH"/md5_linux)
if [ "$md5_cur" != "$md5_img" ]; then
    echo "UPGRADE FAIL: Incorrect CRC"
    exit 1
fi

chmod 777 "$FW_PATH"/utils/upgrade-bin

echo "Upgrade firmware started"
"$FW_PATH"/utils/upgrade-bin "$FW_PATH"/linux.bin
RETVAL=$?

if [ "$RETVAL" != "0" ]; then
    if [ "$RETVAL" = "254" ]; then
    	echo "UPGRADE FAIL: upgrade process is already in progress"
    	exit 2
    fi
    echo "UPGRADE FAIL: Error at read/write operation"
    exit 1
fi

echo "UPGRADE SUCCESSFULL"
reboot
exit 0
